<id>
SSI in YaBB2 Template
</id>

<version>
1.4
</version>

<mod info>
This is an updated version of mod made by Techneaux (Jay Silverman), it has been modified for YaBB2.

This mod lets you use the <!--#include file="filename" --> SSI command in your template.

Version 1.4 Updated for YaBB 2 Final
Version 1.3 Had to rewrite as I previously somehow lost it and released the old version of mod.
Version 1.2 Modified for YaBB2, added listing to ModList.
Version 1.1 fixed a little bug.
</mod info>

<author>
Kong (kong@3dxl.com
</author>

<homepage>
http://www.3dxl.com
</homepage>





<edit file>
Admin/ModList.pl
</edit file>

<search for>
### END BOARDMOD ANCHOR ###
</search for>

<add before>
 	$template_ssi_include = "SSI in YaBB2 Template|Kong|This mod lets you use the &lt;!--#include file=&quot;filename&quot; --&gt; SSI command in your template.|1.4|October 12, 2005";
	push (@installed_mods, "$template_ssi_include");
</add before>





<edit file>
Sources\Subs.pl
</edit file>

<search for>
	@yytemplate = <TEMPLATE>;
	fclose(TEMPLATE);
</search for>

<add after>
	foreach $yytemplate (@yytemplate){
	$yytemplate =~ s/<\!--#include file\s*?=\s*?"(\S+?)"\s*?-->/${\(VNFileLoad($1))}/gi;
	} 
</add after>

<search for>
		$yyurl      = $scripturl;
		$addsession = qq~<input type="hidden" name="formsession" value="$formsession" /></form>~;
		$curline =~ s~<yabb\s+(\w+)>~${"yy$1"}~g;
		$curline =~ s~<includefile="(\S+)">~${\(IncludeFile($1))}~g;
		$curline =~ s~img src\=\"$imagesdir\/(.+?)\"~&ImgLoc($1)~eisg;
		$curline =~ s~alt\=\"(.*?)\"~alt\=\"$1\" title\=\"$1\"~ig;
		$curline =~ s~</form>~$addsession~g;
		$output .= $curline;
	}
	if ($yycopyin == 0) {
		$output = q~<center><h1><b>Sorry, the copyright tag <yabb copyright> must be in the template.<br />Please notify this forum's administrator that this site is using an ILLEGAL copy of YaBB!</b></h1></center>~;
	}

	# do output
	if ($gzcomp && $gzaccept) {
		if ($gzcomp == 1) {
			$| = 1;
			open(GZIP, "| gzip -f");
			print GZIP $output;
			close(GZIP);
		} else {
			require Compress::Zlib;
			binmode STDOUT;
			print Compress::Zlib::memGzip($output);
		}
	} else {
		print $output;
	}
}
</search for>

<add after>

sub VNFileLoad {
     	my $fname = shift;
     	my $file;
     	$fname =~ s/([\&;\`'\|\"*\?\~\^\(\)\[\]\{\}\$\n\r])//g;
     	open(FILE, $fname) || return '[an error occured while processing this directive]';
     	my @file = <FILE>;
     	close(FILE);
     	$file = join('', @file);
     	return $file;
}  
</add after>
